
do '../web-lib.pl';
&init_config();
ReadParse();

use XML::Parser;


my $tfwlib = '/usr/lib/simplefirewall.pm';
if( ! -f $tfwlib ) {
	error( 'SFirewall Library not found. Install SFirewall.' );
}
require $tfwlib;

$fw = new SimpleFirewall;
$fw->LoadFirewall( $config{fw_file} );

my $fwFile;
my $servicesFile;

if( $fwFile eq '' ) { $fwFile = "/etc/webmin/simplefirewall/fw.xml"; }
if( $servicesFile eq '' ) { $servicesFile = "/etc/webmin/simplefirewall/fwservices.xml"; }

$net_scripts_dir = "/etc/sysconfig/network-scripts";
$network_config = "/etc/sysconfig/network";
$static_route_config = "/etc/sysconfig/static-routes";
$sysctl_config = "/etc/sysctl.conf";

# active_interfaces()
# Returns a list of currently ifconfig'd interfaces
sub active_interfaces
{
local(@rv, @lines, $l);
open(IFC, "ifconfig -a |");
while(<IFC>) {
	s/\r|\n//g;
	if (/^\S+/) { push(@lines, $_); }
	else { $lines[$#lines] .= $_; }
	}
close(IFC);
foreach $l (@lines) {
	local %ifc;
	$l =~ /^([^:\s]+)/; $ifc{'name'} = $1;
	$l =~ /^(\S+)/; $ifc{'fullname'} = $1;
	if ($l =~ /^(\S+):(\d+)/) { $ifc{'virtual'} = $2; }
	if ($l =~ /inet addr:(\S+)/) { $ifc{'address'} = $1; }
	elsif (!$_[0]) { next; }
	if ($l =~ /Mask:(\S+)/) { $ifc{'netmask'} = $1; }
	if ($l =~ /Bcast:(\S+)/) { $ifc{'broadcast'} = $1; }
	if ($l =~ /HWaddr (\S+)/) { $ifc{'ether'} = $1; }
	if ($l =~ /MTU:(\d+)/) { $ifc{'mtu'} = $1; }
	$ifc{'up'}++ if ($l =~ /\sUP\s/);
	$ifc{'edit'} = ($ifc{'name'} !~ /^ppp/);
	$ifc{'index'} = scalar(@rv);
	push(@rv, \%ifc);
	}
return @rv;
}




# iface_type(name)
# Returns a human-readable interface type name
sub iface_type
{
    return "PPP" if ($_[0] =~ /^ppp/);
    return "SLIP" if ($_[0] =~ /^sl/);
    return "PLIP" if ($_[0] =~ /^plip/);
    return "Ethernet" if ($_[0] =~ /^eth/);
    return "Arcnet" if ($_[0] =~ /^arc/);
    return "Token Ring" if ($_[0] =~ /^tr/);
    return "Pocket/ATP" if ($_[0] =~ /^atp/);
    return "Loopback" if ($_[0] =~ /^lo/);
    return $text{'ifcs_unknown'};
}


sub iptables_module_run
{
    return `/sbin/iptables -V`;
}

sub ipchains_module_run
{
    return `/sbin/ipchains -V`;
}

sub module_run_now
{
    return $text{'info-ipchains-install'} if(`/sbin/ipchains -L` =~ /^Chain/);
    return $text{'info-iptables-install'} if(`/sbin/iptables -L` =~ /^Chain/);

} 

sub info_additional
{
    return $text{'info-kernel-version-up'} if(`/bin/uname -r` =~ /^2.4/);
    return $text{'info-kernel-version-down'} if(`/bin/uname -r` =~ /^2.2/);
}

sub info_display_rules
{
    return `/sbin/iptables -L -n`;
}

sub info_display_rules_nat
{
    return `/sbin/iptables -t nat -L -n`;
}



sub AddRule 
{
	my ($src, $dst, $service, $port) = @_;
	my %attr = ( 
		     'SRC' => [$src], 
		     'DST' => [$dst], 
		     'SERVICE'=> [$service], 
		     'PORT'=> [$port]
		     );
	
}

sub SaveFirewallAs 
{
    my ($source, $destination, $service, $port) = @_;
    my %attr = ( 
		     'src' => [$source], 
		     'dst' => [$destination], 
		     'service'=> [$service], 
		     'port'=> [$port]
		     );
    
    
	
    my $xml = "<firewall>\n";
    $xml .= "\n";
    for my $i (0..1) {
	$xml .= &attr2xml( 'rule', %attr );
    }
    $xml .= "\n";
    $xml .= "</firewall>\n";
    
    open( FWFILE, ">$fwFile" );
    print FWFILE $xml;
    close( FWFILE );
}


sub attr2xml 
{
    my ($tag,%attr) = @_;
    my $appo = "<$tag";
    
    for $attribute (keys %attr){
	$appo .= " $attribute=@{ $attr{$attribute}} ";
    }
    
    $appo .= "/>\n";
    return $appo;
}



sub wr_squid{
    
    
    
    $http_access  = "http_access allow localhost\n";
    $acl_access = "acl localhost src 127.0.0.1/255.255.255.255\n";
  
    @act = &active_interfaces();
    foreach $a (@act) {
	&netcalculate("$a->{'address'}/$a->{'netmask'}");
	$ipvalid = "$a->{'address'}/$a->{'netmask'}";
	$acl_access .="acl sfirewallcfg$a->{'name'}$a->{'virtual'} src $ipok/$a->{'netmask'}\n";     
	$http_access .= "http_access allow sfirewallcfg$a->{'name'}$a->{'virtual'}\n";
    }

    
    
    my $wrold = '';
    open(FH,"/etc/squid/squid.conf");
    while(<FH>){
	if(/sfirewallcfg/){
	    if(/$ipvalid/){
		$wrold = 1;
	    }
	}
    }
    close(FH);
    if($wrold ne 1){
	open(FILE, "/etc/squid/squid.conf");
	while(<FILE>){
	    if(/http_access allow localhost/){
		$. = $.-1;
		&replace_file_line("/etc/squid/squid.conf","$.","$http_access");
	    }
	}
	close(FILE);
	open(FILE, "/etc/squid/squid.conf");
	while(<FILE>){
	    if(/acl localhost src/){
		$. = $.-1;
		&replace_file_line("/etc/squid/squid.conf","$.","$acl_access");
		
	    }
	    
	}
	close(FILE);
    }
	
}	
    




sub netcalculate
{
my $tput = $ENV{'TPUT'};
$tput = 'tput' if (!defined($tput));

(my $ipaddr , my  $mask) = @_;


my @ia;         # individual bytes of ipaddr
my @nm;         # individual bytes of netmask
my $netmask;    # netmask as 32 bit value
my $maskbits;   # number of bits in netmask
my $i;          # work
my @j;          # work

if (!defined($ipaddr)) {
        &usage();
}

# gotta love those Perl regular expressions :)
if ($ipaddr =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)(?:\/([\d.]+))?$/) {
        (@ia) = ($1, $2, $3, $4);
        $mask = $5;
}
else {
        &usage("Parameter $ipaddr not recognised");
}

for ($i = 0; $i < 4; ++$i) {
        if ($ia[$i] > 255) {
                &usage("Invalid byte $ia[$i] in IPv4 address, must be 0-255");
        }
}
if ($ia[0] < 1 || $ia[0] > 223) {
        &usage("First byte must be 1-223, I do not handle multicast or experimental");
}

if (!defined($mask)) {
        # default to class A, B or C
        if ($ia[0] < 128) {
                $mask = 8;
        }
        elsif ($ia[0] < 192) {
                $mask = 16;
        }
        else {
                $mask = 24;
        }
}


if ($mask =~ /^\d+$/) {
        # user supplied number of bits or we defaulted to number of bits in netmask
        $maskbits = $mask;
        $mask = undef();        # don't use user supplied value any more
        if ($maskbits <= 32) {
                # use integer implies signed shift, I want unsigned
                no integer;
                # only assumption is at least 32 bit arithmetic, should handle > 32 bits
                $i = 0xffffffff << (32 - $maskbits) & 0xffffffff;
                $i = 0 if ($maskbits == 0);     # shift left 32 may do nothing
                (@nm) = ($i >> 24, $i >> 16 & 0xff, $i >> 8 & 0xff, $i & 0xff);
                use integer;
        }
        else {
                &usage("Netmask bits must be 0-32, $maskbits is invalid");
        }
}
elsif ($mask =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/) {
        # user supplied dotted quad netmask
        (@nm) = ($1, $2, $3, $4);
        $mask = undef();        # don't use user supplied value any more
        for ($i = 0; $i < 4; ++$i) {
                if ($nm[$i] > 255) {
                        &usage("Invalid byte $nm[$i] in netmask, must be 0-255");
                }
        }
}
else {
        &usage("Netmask must be 0-32 or dotted quad, $mask is invalid");
}

no integer;     # do unsigned shift
$ipaddr  = ($ia[0] << 24) + ($ia[1] << 16) + ($ia[2] << 8) + $ia[3];
$netmask = ($nm[0] << 24) + ($nm[1] << 16) + ($nm[2] << 8) + $nm[3];
for ($maskbits = 0, $i = $netmask; $i != 0; ++$maskbits) {
        if (($i & 0xc0000000) == 0x40000000) {
                &usage("Netmask must have contiguous leftmost '1' bits,  " . sprintf("%08X", $netmask) . " is invalid");
        }
        $i <<= 1;
}
use integer;
if ($maskbits < 31) {
        no integer;     # do unsigned arithmetic
        $i = $ipaddr & $netmask;
        $j = $i>> 24;
	$k = $i>>16 & 0xff ;
	$l = $i >> 8 & 0xff;
	$m = $i & 0xff;
	$ipok = "$j.$k.$l.$m";
	use integer;
	return($ipok);
	
}
else {
        printf("Network          None, mask >= 31\n");
}

}








1;
