#!/usr/bin/perl

do 'lib.pl';

my $net = $in{'net'};
my $ip = $in{'ip'};
my $netmask = $in{'netmask'};
my $zone = $in{'zone'};

if( $in{'delete'} ) {
	# delete net
	$whatfailed = 'Fail to delete net';
	$fw->DeleteNet($net);
} else {
	if( $in{'new'} ) {
		$whatfailed = 'Fail to create new net';
		my @allitems = $fw->GetAllItemsList();
		foreach my $i (@allitems) {
			if( $i eq $net ) {
				error(" Item '$net' already present");
			}
		}
	} else {
		$whatfailed = 'Fail to save net';
	}
	if ( $net eq '' ) { error('net name field can\'t be empty'); }
	if ( ! $fw->GetZone($zone) ) { error('wrong zone'); }
	if ( $ip !~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/ ) { error('wrong ip address'); }
	if ( $netmask !~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/ ) { error('wrong netmask'); }
	$fw->AddNet( $net, $ip, $netmask, $zone );
}

$fw->SaveFirewall();
redirect( 'xzone.cgi' );

